/*******************************************************
 *  Unit test for the hour class
 *
 * test the date parser that converts String to hour
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   hour   h0;
   String the_time;


   the_time = "1134";
   h0 = hour(the_time);
   std::cout << "String \"" << the_time << "\" converts to: \"" << h0 << "\"\n";
   std::cout.flush();
   assert(h0 == hour(11, 34, 0));

   the_time = "11:34";
   h0 = hour(the_time);
   std::cout << "String \"" << the_time << "\" converts to: \"" << h0 << "\"\n";
   assert(h0 == hour(11, 34, 0));

   the_time = "11.34";
   h0 = hour(the_time);
   std::cout << "String \"" << the_time << "\" converts to: \"" << h0 << "\"\n";
   assert(h0 == hour(11, 34, 0));

   the_time = "113427";
   h0 = hour(the_time);
   std::cout << "String \"" << the_time << "\" converts to: \"" << h0 << "\"\n";
   assert(h0 == hour(11, 34, 27));

   the_time = "11:34:27";
   h0 = hour(the_time);
   std::cout << "String \"" << the_time << "\" converts to: \"" << h0 << "\"\n";
   assert(h0 == hour(11, 34, 27));

   the_time = "11.34.27";
   h0 = hour(the_time);
   std::cout << "String \"" << the_time << "\" converts to: \"" << h0 << "\"\n";
   assert(h0 == hour(11, 34, 27));

   //  TODO: test for invalid houts and syntax errors

   return 0;
}

