/*******************************************************
 *  Unit test for the String class
 *
 * test addition operators
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // Default contructor: empty string
   String s0;

   String s1("abc");
   String s2("def");
   String s3, s4;

   s3 = s1 + s2;
   std::cout << s1 << " + " << s2 << " = " << s3 << "\n";
   assert(s3 == "abcdef");
   s4 = s2 + s1;
   std::cout << s2 << " + " << s1 << " = " << s4 << "\n";
   assert(s4 == "defabc");

   s3 = s1;
   s3 += s2;
   std::cout << s1 << " += " << s2 << " = " << s3 << "\n";
   assert(s3 == "abcdef");

   return 0;
}

