/*******************************************************
 *  Unit test for the SuperString class
 *
 * test addition operators
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

void print_ss(SuperString ss)
{
   std::cout << "[";
   for (int i = 0; i < ~ss; i++)
   {
      if (i != 0)
         std::cout << ",";
      std::cout << "\"" << ss[i] << "\"";
   }
   std::cout << "]";
}

int main()
{
   // Add a String to a SuperString, + operator(SuperString, String)

   SuperString ss0;

   String s1("abc");
   String s2("def");
   SuperString ss1(s1);

   ss0 = ss1 + s2;

   print_ss(ss1);
   std::cout << " + " << s2 << " = ";
   print_ss(ss0);
   std::cout << "\n";

   // Add a String to a SuperString, += operator

   SuperString ss2;

   String s3("uvw");
   String s4("xyz");

   ss2 += s3;
   print_ss(ss2);
   std::cout << "\n";

   ss2 += s4;
   print_ss(ss2);
   std::cout << "\n";

   // Add a String to a SuperString, + operator(String, SuperString)

   SuperString ss4;

   String s5("abc");
   String s6("def");
   SuperString ss5(s5);

   ss4 = s6 + ss5;

   std::cout << s6 << " + ";
   print_ss(ss5);
   std::cout << " = ";
   print_ss(ss4);
   std::cout << "\n";

   // Add a SuperString  to a SuperString, + operator(SuperString, SuperString)
 
   SuperString  ss7(2);
   SuperString  ss8(2);
   SuperString  ss9;

   ss7[0] = "abc";
   ss7[1] = "def";
   ss8[0] = "uvw";
   ss8[1] = "xyz";

   ss9 = ss7 + ss8;

   print_ss(ss7);
   std::cout << " + ";
   print_ss(ss8);
   std::cout << " = ";
   print_ss(ss9);
   std::cout << "\n";

   return 0;
}

