/*******************************************************
 *  Unit test for the configuration class
 *
 * test finding configuration parameters
 ******************************************************
 *
 */

#include "configuration.h"
#include <assert.h>

int main()
{
   configuration  config1;
   bool           result;
   String         value;

   result = config1.read("ACL");
   assert(result == true);

   value = config1.find_parameter("section", "parameter");
   assert(value == "Test1");

   // Wrong parameter
   value = config1.find_parameter("section", "not_exist");
   assert(value == "");

   // Wrong section
   value = config1.find_parameter("not_exist", "parameter");
   assert(value == "");

   return 0;
}

