/*******************************************************
 *  Unit test for the Integer class
 *
 * test several functions with a factorial calculation
 ******************************************************
 *
 */

#include "Integer.h"
#include <assert.h>


void facttest(Integer& one, Integer& two);

int main()
{
  Integer one = 1;
  std::cout << "one = " << one << "\n";
  assert(one.OK());
  assert(one == 1);
  std::cout << "one + 1 = " << (one + long(1)) << "\n";

  Integer two = 2;
  std::cout << "two = " << two << "\n";
  assert(two.OK());
  assert(two == 2);

  facttest(one, two);
  //anothertest();
  //iotest();
  //modtest();

  std::cout << "\nEnd of test\n";
}
